#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<long long> fib(600);

long long f(long long a, long long k) {
	if (a < 2) return 0;
	long long ans = 0;
	for (long long i = k; i >1; i--) {
		if (a%fib[i] == 0) {
			if (a == fib[i]) ans++;
			else {
				ans += f(a / fib[i], i);
			}
		}
	}
	return ans;
}

signed main()
{
	
	fib[0] = fib[1] = 1;
	for (long long i = 2; i < 87; i++) {
		fib[i] = fib[i - 1] + fib[i - 2];
		//if (long long(pow(2, long long(log2(fib[i])))) == fib[i]) cout << fib[i] <<" ";
	}
	long long t;
	cin>>t;
	while (t--) {
		long long n;
		cin >> n;
		cout << f(n, 86) << '\n';
	}
}
