#include <iostream>
#include <vector>

using namespace std;

struct q {
	long long z, a, b;
	q(long long _z, long long _a, long long _b) {
		z = _z;
		a = _a;
		b = _b;
	}
	q() {
		z = 0;
		a = 0;
		b = 0;
	}
};

signed main()
{
	long long n, p;
	cin >> n >> p;
	vector<q> z(n);
	for (long long i = 0; i < n; i++) {
		long long z1, a, b;
		cin >> z1 >> a >> b;
		z[i] = q(z1, a, b);
	}
	long long l = 0, r = 1e15;
	while (l + 1 < r) {
		long long m = (l + r) / 2;
		long long ans = 0;
		for (long long i = 0; i < n; i++) {
			if (m <= z[i].z) {
				ans += z[i].a*m;
			}
			else {
				ans += z[i].a*z[i].z + z[i].b*(m - z[i].z);
				if (ans > p) {
					ans = 1e18;
					break;
				}
			}
		}
		if (ans < p) l = m;
		else r = m;
	}
	cout << r;
}
