#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <map>

using namespace std;

struct otr {
	int x, l, r;
	otr(int _x, int _l, int _r) {
		x = _x;
		l = _l;
		r = _r;
	}
	bool operator<(otr A) {
		if(l!=A.l)
			return l < A.l;
		else {
			return r < A.r;
		}
	}
};

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	long long k, n;
	cin >> k >> n;
	unordered_set<long long> ans;
	if (k != 1) {
		pair<long long, long long> q = { 0, 0 };
		vector<pair<char, long long>> ques;
		bool c1 = true;
		for (long long i = 0; i < n; i++) {
			char c;
			long long d;
			cin >> c >> d;
			ques.push_back({ c, d });
			if (d != k) c1 = 0;
		}
		if (c1 == 0) {
			for (long long i = 0; i < k; i++) {
				for (long long j = 0; j < k; j++) {
					ans.insert(i * 1000000000 + j);
				}
			}
			for (long long ii = 0; ii < n; ii++) {
				char c;
				long long d;
				c = ques[ii].first;
				d = ques[ii].second;
				//cin >> c >> d;
				if (c == 'S') {
					for (long long i = q.first; i < q.first + k; i++) {
						for (long long j = q.second - d; j < q.second; j++) {
							ans.insert(i * 1000000000 + j);
						}
					}
					q = { q.first, q.second - d };
				}
				if (c == 'N') {
					for (long long i = q.first; i < q.first + k; i++) {
						for (long long j = q.second + k; j < q.second + d + k; j++) {
							ans.insert(i * 1000000000 + j);
						}
					}
					q = { q.first, q.second + d };
				}
				if (c == 'E') {
					for (long long i = q.first + k; i < q.first + d + k; i++) {
						for (long long j = q.second; j < q.second + k; j++) {
							ans.insert(i * 1000000000 + j);
						}
					}
					q = { q.first + d, q.second };
				}
				if (c == 'W') {
					for (long long i = q.first - d; i < q.first; i++) {
						for (long long j = q.second; j < q.second + k; j++) {
							ans.insert(i * 1000000000 + j);
						}
					}
					q = { q.first - d, q.second };
				}
			}
			cout << ans.size();
		}
		else {
			ans.clear();
			ans.insert(0);
			long long kk = k;
			k = 1;
			for (long long ii = 0; ii < n; ii++) {
				char c;
				long long d;
				c = ques[ii].first;
				d = 1;
				//cin >> c >> d;
				if (c == 'S') {
					for (long long i = q.first; i < q.first + k; i++) {
						for (long long j = q.second - d; j < q.second; j++) {
							ans.insert(i * 1000000000 + j);
						}
					}
					q = { q.first, q.second - d };
				}
				if (c == 'N') {
					for (long long i = q.first; i < q.first + k; i++) {
						for (long long j = q.second + k; j < q.second + d + k; j++) {
							ans.insert(i * 1000000000 + j);
						}
					}
					q = { q.first, q.second + d };
				}
				if (c == 'E') {
					for (long long i = q.first + k; i < q.first + d + k; i++) {
						for (long long j = q.second; j < q.second + k; j++) {
							ans.insert(i * 1000000000 + j);
						}
					}
					q = { q.first + d, q.second };
				}
				if (c == 'W') {
					for (long long i = q.first - d; i < q.first; i++) {
						for (long long j = q.second; j < q.second + k; j++) {
							ans.insert(i * 1000000000 + j);
						}
					}
					q = { q.first - d, q.second };
				}
			}
			cout << (ans.size())*kk*kk;
		}
	}
	else {
		map<int, vector<otr>> a1, a2;
		int x = 0, y = 0;
		for (int i = 0; i < n; i++) {
			char c;
			int d;
			cin >> c >> d;
			if (c == 'E') {
				a1[y].push_back(otr(y, x, x + d));
				x = x + d;
			}
			if (c == 'W') {
				a1[y].push_back(otr(y, x - d, x));
				x = x - d;
			}
			if (c == 'N') {
				a2[x].push_back(otr(x, y, y + d));
				y = y + d;
			}
			if (c == 'S') {
				a2[x].push_back(otr(x, y - d, y));
				y = y - d;
			}
		}
		for (auto &i : a1) {
			sort(i.second.begin(), i.second.end());
		}
		for (auto &i : a2) {
			sort(i.second.begin(), i.second.end());
		}

		
		for (auto &i : a1) {
			for (int j = 0; j < i.second.size(); j++) {
				for (int k = j + 1; k < i.second.size(); j++) {
					if (i.second[k].x == -1e9 - 1 || i.second[j].x == -1e9 - 1) continue;
					if (i.second[k].l < i.second[j].r) {
						i.second[j].x = -1e9 - 1;
						i.second[j].r = i.second[k].r;
					}
				}
			}
		}
		for (auto &i : a2) {
			for (int j = 0; j < i.second.size(); j++) {
				for (int k = j + 1; k < i.second.size(); j++) {
					if (i.second[k].x == -1e9 - 1 || i.second[j].x == -1e9 - 1) continue;
					if (i.second[k].l < i.second[j].r) {
						i.second[j].x = -1e9 - 1;
						i.second[j].r = i.second[k].r;
					}
				}
			}
		}
int q = 0;
		cout << 5 / q;
		vector<otr> b1, b2;
		int ans = 0;
		for (auto &i : a1) {
			for (auto &j : i.second) {
				if (j.x != -1e9 - 1) {
					b1.push_back(j);
					ans += (j.r - j.l + 1);
				}
			}
		}
		for (auto &i : a2) {
			for (auto &j : i.second) {
				if (j.x != -1e9 - 1) {
					b2.push_back(j);
					ans += (j.r - j.l + 1);
				}
			}
		}

		for (auto &i : b1) {
			for (auto &j : b2) {
				if (i.x >= j.l && i.x <= j.r && j.x >= i.l && j.x <= i.r) ans--;
			}
		}
		cout << ans;

	}

}
/*
1 5
E 2
N 2
W 4
S 4
E 4

3 4
W 2
N 1
W 1
N 2
*/