#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>

using namespace std;

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	long long k, n;
	cin >> k >> n;
	unordered_set<long long> ans;
	for (long long i = 0; i < k; i++) {
		for (long long j = 0; j < k; j++) {
			ans.insert(i * 1000000000 + j);
		}
	}
	pair<long long, long long> q = { 0, 0 };
	while (n--) {
		char c;
		long long d;
		cin >> c >> d;
		if (c == 'S') {
			for (long long i = q.first; i < q.first + k; i++) {
				for (long long j = q.second - d; j < q.second; j++) {
					ans.insert( i*1000000000+ j );
				}
			}
			q = { q.first, q.second - d };
		}
		if (c == 'N') {
			for (long long i = q.first; i < q.first + k; i++) {
				for (long long j = q.second + k; j < q.second + d + k; j++) {
					ans.insert(i * 1000000000 + j);
				}
			}
			q = { q.first, q.second  + d};
		}
		if (c == 'E') {
			for (long long i = q.first + k; i < q.first + d+ k; i++) {
				for (long long j = q.second; j < q.second + k; j++) {
					ans.insert(i * 1000000000 + j);
				}
			}
			q = { q.first + d, q.second };
		}
		if (c == 'W') {
			for (long long i = q.first - d; i < q.first; i++) {
				for (long long j = q.second; j < q.second + k; j++) {
					ans.insert(i * 1000000000 + j);
				}
			}
			q = { q.first - d, q.second };
		}
	}
	cout << ans.size();
}
/*
1 5
E 2
N 2
W 4
S 4
E 4

3 4
W 2
N 1
W 1
N 2
*/