#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;

signed main(){
	int n, q;
	cin >> n >> q;
	vector<int> z(n);
	for (int i = 0; i < n; i++) {
		cin >> z[i];
	}
	vector<vector<int>> dp(n);
	for (int i = 0; i < n; i++) {
		int l = i, r = i;
		dp[i].push_back(i);
		for (int j = 1; j < n; j++) {
			int l1 = 1e9, r1 = 1e9;
			if (l != 0) {
				l1 = z[l - 1];
			}
			if (r != n - 1) {
				r1 = z[r + 1];
			}
			if (l1 < r1) {
				dp[i].push_back(l - 1);
				l--;
			}
			else {
				dp[i].push_back(r + 1);
				r++;
			}
		}
	}
	vector<vector<int>> ans(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			ans[dp[i][j]][j]++;
		}
	}
	for (int i = 0; i < q; i++) {
		int p, k;
		cin >> p >> k;
		p--, k--;
		cout << ans[p][k] << '\n';
	}
}
