#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;



signed main() {
	int n, q;
	cin >> n >> q;
	vector<int> z;
	z.resize(n+2);
	z[0] = z[n + 1] = 1e9;
	for (int i = 1; i <= n; i++) {
		cin >> z[i];
	}
	int j = 0;
	vector<int> lg(n + 5);
	lg[1] = 0;
	for (int i = 2; i <= n + 1;) {
		if (1 << (j+1) > i) {
			lg[i] = j;
			i++;
		}
		else j++;
	}
	vector<vector<pair<int, int>>> sparse(lg[n] + 1, vector<pair<int, int>>(n+2));
	for (int i = 0; i < n + 2; i++) {
		sparse[0][i] = { z[i], i };
	}
	for (int i = 1; i <= lg[n]; i++) {
		for (int j = 0; j < n+2; j++) {
			sparse[i][j] = max(sparse[i - 1][j], sparse[i - 1][min(n + 1, j + (1 << (i - 1)))]);
		}
	}
	for (int i = 0; i < q; i++) {
		int p, k;
		cin >> p >> k;
		if (k == 1) {
			cout << 1 << '\n';
			continue;
		}
		k--;
		int ans1 = 0, ans2=0;
		if (p + k < n + 1) {
			auto a = max(sparse[lg[k]][p + 1], sparse[lg[k]][1+p + k - (1 << (lg[k]))]);
			int r = z[p + k + 1], l = z[p];
			if (r > l) {
				if (a.first > r) ans1 = 0;
				else if (a.first < l) ans1 = k-1;
				else if (a.first > l && a.first < r) {
					ans1 = p + k + 1 - a.second - 1;
				}
				ans1++;
			}
		}
		if (p - k > 0) {
			auto a = max(sparse[lg[k]][p - (1 << lg[k])], sparse[lg[k]][p - k ]);
			int r = z[p], l = z[p - k - 1];
			if (r > l) {
				if (a.first > r) ans2 = 0;
				else if (a.first < l) ans2 = k-1;
				else if (a.first > l && a.first < r) {
					ans2 =  a.second - p + k + 1  - 1;
				}
				ans2++;
			}
		}
		cout << ans1 + ans2 << '\n';
	}
}
/*
6 4
1 4 6 5 2 3
3 1
2 2
6 3
4 3
*/